Index: src/edu/ucsb/nceas/metacat/DocumentImpl.java
===================================================================
--- src/edu/ucsb/nceas/metacat/DocumentImpl.java	(revision 5014)
+++ src/edu/ucsb/nceas/metacat/DocumentImpl.java	(revision 5015)
@@ -53,15 +53,19 @@
 import java.util.regex.Matcher;
 import java.util.regex.Pattern;
 
-import edu.ucsb.nceas.metacat.service.DatabaseService;
+import edu.ucsb.nceas.metacat.database.DBConnection;
+import edu.ucsb.nceas.metacat.database.DBConnectionPool;
+import edu.ucsb.nceas.metacat.database.DatabaseService;
+import edu.ucsb.nceas.metacat.replication.ForceReplicationHandler;
+import edu.ucsb.nceas.metacat.replication.ReplicationService;
 import edu.ucsb.nceas.metacat.service.PropertyService;
 import edu.ucsb.nceas.metacat.service.XMLSchema;
 import edu.ucsb.nceas.metacat.service.XMLSchemaService;
+import edu.ucsb.nceas.metacat.shared.MetacatUtilException;
 import edu.ucsb.nceas.metacat.spatial.SpatialHarvester;
 import edu.ucsb.nceas.metacat.util.AuthUtil;
 import edu.ucsb.nceas.metacat.util.MetacatUtil;
 import edu.ucsb.nceas.metacat.util.SystemUtil;
-import edu.ucsb.nceas.metacat.util.MetacatUtilException;
 import edu.ucsb.nceas.utilities.FileUtil;
 import edu.ucsb.nceas.utilities.PropertyNotFoundException;
 import edu.ucsb.nceas.utilities.StringUtil;
@@ -157,6 +161,7 @@
     private TreeSet<NodeRecord> nodeRecordList = null;
   
     private static Logger logMetacat = Logger.getLogger(DocumentImpl.class);
+    private static Logger logReplication = Logger.getLogger("ReplicationLogging");
 
     /**
      * Default constructor
@@ -696,7 +701,7 @@
          {
            logMetacat.error("Local rev for docid "+ docid + " could not "+
                                   " be found because " + e.getMessage());
-           MetacatReplication.replErrorLog("Docid "+ docid + " could not be "+
+           logReplication.error("Docid "+ docid + " could not be "+
                    "written because error happend to find it's local revision");
            throw new Exception (e.getMessage());
          }
@@ -762,20 +767,20 @@
             //saying that he/she needs to download a new copy of the file and
             //merge the differences manually.
 
-            String server = MetacatReplication
+            String server = ReplicationService
                     .getServerNameForServerCode(serverCode);
-            MetacatReplication.replLog("attempting to lock " + accnum);
+            logReplication.info("attempting to lock " + accnum);
             URL u = new URL("https://" + server + "?server="
                     + MetacatUtil.getLocalReplicationServerName()
                     + "&action=getlock&updaterev=" + rev + "&docid=" + docid);
             //System.out.println("sending message: " + u.toString());
-            String serverResStr = MetacatReplication.getURLContent(u);
+            String serverResStr = ReplicationService.getURLContent(u);
             String openingtag = serverResStr.substring(0, serverResStr
                     .indexOf(">") + 1);
             if (openingtag.equals("<lockgranted>")) {
                 //the lock was granted go ahead with the insert
                 //System.out.println("In lockgranted");
-                MetacatReplication.replLog("lock granted for " + accnum
+            	logReplication.info("lock granted for " + accnum
                         + " from " + server);
                 flag = true;
                 return flag;
@@ -788,7 +793,7 @@
                 // and try
                 //again.
                 //System.out.println("file locked");
-                MetacatReplication.replLog("lock denied for " + accnum + " on "
+            	logReplication.error("lock denied for " + accnum + " on "
                         + server + " reason: file already locked");
                 throw new Exception(
                         "The file specified is already locked by another "
@@ -802,7 +807,7 @@
                                                              // copy of the
                 //file and merge his version with the new version.
                 //System.out.println("outdated file");
-                MetacatReplication.replLog("lock denied for " + accnum + " on "
+            	logReplication.error("lock denied for " + accnum + " on "
                         + server + " reason: local file outdated");
                 throw new Exception(
                         "The file you are trying to update is an outdated"
@@ -2566,15 +2571,15 @@
             //DocumentIdentifier id = new DocumentIdentifier(accnum);
             int revision = MetacatUtil.getRevisionFromAccessionNumber(accnum);
             String updaterev = (new Integer(revision)).toString();
-            String server = MetacatReplication
+            String server = ReplicationService
                     .getServerNameForServerCode(serverCode);
-            MetacatReplication.replLog("attempting to lock " + accnum);
+            logReplication.info("attempting to lock " + accnum);
             URL u = new URL("https://" + server + "?server="
                     + MetacatUtil.getLocalReplicationServerName()
                     + "&action=getlock&updaterev=" + updaterev + "&docid="
                     + docid);
             //System.out.println("sending message: " + u.toString());
-            String serverResStr = MetacatReplication.getURLContent(u);
+            String serverResStr = ReplicationService.getURLContent(u);
             String openingtag = serverResStr.substring(0, serverResStr
                     .indexOf(">") + 1);
             if (openingtag.equals("<lockgranted>")) {//the lock was granted go
@@ -2582,7 +2587,7 @@
                 XMLReader parser = null;
                 try {
                     //System.out.println("In lockgranted");
-                    MetacatReplication.replLog("lock granted for " + accnum
+                	logReplication.info("lock granted for " + accnum
                             + " from " + server);
                     /*
                      * XMLReader parser = initializeParser(conn, action, docid,
@@ -2636,7 +2641,7 @@
                 // the file is currently locked by another user notify our
                 // user to wait a few minutes, check out a new copy and try
                 // again.
-                MetacatReplication.replLog("lock denied for " + accnum + " on "
+            	logReplication.error("lock denied for " + accnum + " on "
                         + server + " reason: file already locked");
                 throw new Exception(
                         "The file specified is already locked by another "
@@ -2647,7 +2652,7 @@
                 // our file is outdated. notify our user to check out a new
                 // copy of the file and merge his version with the new version.
                 //System.out.println("outdated file");
-                MetacatReplication.replLog("lock denied for " + accnum + " on "
+            	logReplication.info("lock denied for " + accnum + " on "
                         + server + " reason: local file outdated");
                 throw new Exception(
                         "The file you are trying to update is an outdated"
@@ -2910,7 +2915,7 @@
                 // we need to delete the nodes in xml_ndoes.
                 deleteXMLNodes(conn, rootId);
             }
-            MetacatReplication.replErrorLog("Failed to " + "create access "
+            logReplication.error("Failed to " + "create access "
                     + "rule for package: " + accnum + " because "
                     + ee.getMessage());
             logMetacat.error("Failed to  " + "create access "
Index: src/edu/ucsb/nceas/metacat/DocumentImplWrapper.java
===================================================================
--- src/edu/ucsb/nceas/metacat/DocumentImplWrapper.java	(revision 5014)
+++ src/edu/ucsb/nceas/metacat/DocumentImplWrapper.java	(revision 5015)
@@ -29,6 +29,8 @@
 
 import java.io.Reader;
 
+import edu.ucsb.nceas.metacat.database.DBConnection;
+
 //import edu.ucsb.nceas.metacat.spatial.MetacatSpatialDocument;
 
 /**
Index: src/edu/ucsb/nceas/metacat/DBSAXNode.java
===================================================================
--- src/edu/ucsb/nceas/metacat/DBSAXNode.java	(revision 5014)
+++ src/edu/ucsb/nceas/metacat/DBSAXNode.java	(revision 5015)
@@ -32,7 +32,9 @@
 import org.apache.log4j.Logger;
 import org.xml.sax.SAXException;
 
-import edu.ucsb.nceas.metacat.service.DatabaseService;
+import edu.ucsb.nceas.metacat.database.DBConnection;
+import edu.ucsb.nceas.metacat.database.DBConnectionPool;
+import edu.ucsb.nceas.metacat.database.DatabaseService;
 
 /**
  * A Class that represents an XML node and its contents and
Index: src/edu/ucsb/nceas/metacat/RelationHandler.java
===================================================================
--- src/edu/ucsb/nceas/metacat/RelationHandler.java	(revision 5014)
+++ src/edu/ucsb/nceas/metacat/RelationHandler.java	(revision 5015)
@@ -20,6 +20,8 @@
  
 package edu.ucsb.nceas.metacat;
 
+import edu.ucsb.nceas.metacat.database.DBConnection;
+import edu.ucsb.nceas.metacat.database.DBConnectionPool;
 import edu.ucsb.nceas.metacat.service.PropertyService;
 import edu.ucsb.nceas.metacat.util.MetacatUtil;
 import edu.ucsb.nceas.morpho.datapackage.Triple;
Index: src/edu/ucsb/nceas/metacat/service/ServiceService.java
===================================================================
--- src/edu/ucsb/nceas/metacat/service/ServiceService.java	(revision 5014)
+++ src/edu/ucsb/nceas/metacat/service/ServiceService.java	(revision 5015)
@@ -32,6 +32,8 @@
 import java.util.Hashtable;
 import java.util.Set;
 
+import edu.ucsb.nceas.metacat.shared.BaseService;
+import edu.ucsb.nceas.metacat.shared.ServiceException;
 import edu.ucsb.nceas.metacat.util.SystemUtil;
 
 public class ServiceService {
Index: src/edu/ucsb/nceas/metacat/service/XMLSchemaService.java
===================================================================
--- src/edu/ucsb/nceas/metacat/service/XMLSchemaService.java	(revision 5014)
+++ src/edu/ucsb/nceas/metacat/service/XMLSchemaService.java	(revision 5015)
@@ -37,10 +37,12 @@
 
 import org.apache.log4j.Logger;
 
-import edu.ucsb.nceas.metacat.DBConnection;
-import edu.ucsb.nceas.metacat.DBConnectionPool;
 import edu.ucsb.nceas.metacat.DocumentImpl;
 import edu.ucsb.nceas.metacat.MetaCatServlet;
+import edu.ucsb.nceas.metacat.database.DBConnection;
+import edu.ucsb.nceas.metacat.database.DBConnectionPool;
+import edu.ucsb.nceas.metacat.shared.BaseService;
+import edu.ucsb.nceas.metacat.shared.ServiceException;
 import edu.ucsb.nceas.utilities.FileUtil;
 import edu.ucsb.nceas.utilities.PropertyNotFoundException;
 import edu.ucsb.nceas.utilities.StringUtil;
@@ -75,6 +77,8 @@
 	 */
 	private XMLSchemaService() {
 		try {
+			_serviceName = "XMLSchemaService";
+			
 			setUseFullSchemaValidation();
 			populateRegisteredSchemaList();
 			createRegisteredNameSpaceList();
Index: src/edu/ucsb/nceas/metacat/service/PropertyService.java
===================================================================
--- src/edu/ucsb/nceas/metacat/service/PropertyService.java	(revision 5014)
+++ src/edu/ucsb/nceas/metacat/service/PropertyService.java	(revision 5015)
@@ -37,8 +37,10 @@
 
 import org.apache.log4j.Logger;
 
+import edu.ucsb.nceas.metacat.shared.BaseService;
+import edu.ucsb.nceas.metacat.shared.MetacatUtilException;
+import edu.ucsb.nceas.metacat.shared.ServiceException;
 import edu.ucsb.nceas.metacat.util.SystemUtil;
-import edu.ucsb.nceas.metacat.util.MetacatUtilException;
 import edu.ucsb.nceas.utilities.FileUtil;
 import edu.ucsb.nceas.utilities.GeneralPropertyException;
 import edu.ucsb.nceas.utilities.MetaDataProperty;
@@ -91,7 +93,9 @@
 	 * 
 	 * @param servletContext the context we will use to get relative paths
 	 */
-	private PropertyService() throws ServiceException {
+	private PropertyService() throws ServiceException {		
+		_serviceName = "PropertyService";
+		
 		initialize();		
 	}
 	
Index: src/edu/ucsb/nceas/metacat/AccessionNumber.java
===================================================================
--- src/edu/ucsb/nceas/metacat/AccessionNumber.java	(revision 5014)
+++ src/edu/ucsb/nceas/metacat/AccessionNumber.java	(revision 5015)
@@ -31,6 +31,8 @@
 import java.sql.ResultSet;
 import java.sql.SQLException;
 
+import edu.ucsb.nceas.metacat.database.DBConnection;
+import edu.ucsb.nceas.metacat.database.DBConnectionPool;
 import edu.ucsb.nceas.metacat.service.PropertyService;
 import edu.ucsb.nceas.utilities.PropertyNotFoundException;
 
Index: src/edu/ucsb/nceas/metacat/workflow/WorkflowScheduler.java
===================================================================
--- src/edu/ucsb/nceas/metacat/workflow/WorkflowScheduler.java	(revision 5014)
+++ src/edu/ucsb/nceas/metacat/workflow/WorkflowScheduler.java	(revision 5015)
@@ -44,11 +44,11 @@
 import edu.ucsb.nceas.metacat.scheduler.ScheduledJobParamDAO;
 import edu.ucsb.nceas.metacat.scheduler.SchedulerService;
 import edu.ucsb.nceas.metacat.scheduler.MetacatSchedulerException;
-import edu.ucsb.nceas.metacat.service.ServiceException;
+import edu.ucsb.nceas.metacat.shared.AccessException;
+import edu.ucsb.nceas.metacat.shared.ServiceException;
 import edu.ucsb.nceas.metacat.util.ErrorSendingErrorException;
 import edu.ucsb.nceas.metacat.util.ResponseUtil;
 import edu.ucsb.nceas.metacat.util.RequestUtil;
-import edu.ucsb.nceas.shared.AccessException;
 import edu.ucsb.nceas.utilities.DateUtil;
 import edu.ucsb.nceas.utilities.UtilException;
 
Index: src/edu/ucsb/nceas/metacat/util/GeoserverUtil.java
===================================================================
--- src/edu/ucsb/nceas/metacat/util/GeoserverUtil.java	(revision 5014)
+++ src/edu/ucsb/nceas/metacat/util/GeoserverUtil.java	(revision 5015)
@@ -33,6 +33,7 @@
 import java.util.HashMap;
 
 import edu.ucsb.nceas.metacat.service.PropertyService;
+import edu.ucsb.nceas.metacat.shared.MetacatUtilException;
 import edu.ucsb.nceas.utilities.FileUtil;
 import edu.ucsb.nceas.utilities.PropertyNotFoundException;
 
Index: src/edu/ucsb/nceas/metacat/util/SkinUtil.java
===================================================================
--- src/edu/ucsb/nceas/metacat/util/SkinUtil.java	(revision 5014)
+++ src/edu/ucsb/nceas/metacat/util/SkinUtil.java	(revision 5015)
@@ -31,6 +31,7 @@
 import org.apache.log4j.Logger;
 
 import edu.ucsb.nceas.metacat.service.PropertyService;
+import edu.ucsb.nceas.metacat.shared.MetacatUtilException;
 import edu.ucsb.nceas.utilities.PropertyNotFoundException;
 import edu.ucsb.nceas.utilities.StringUtil;
 
Index: src/edu/ucsb/nceas/metacat/util/MetacatUtil.java
===================================================================
--- src/edu/ucsb/nceas/metacat/util/MetacatUtil.java	(revision 5014)
+++ src/edu/ucsb/nceas/metacat/util/MetacatUtil.java	(revision 5015)
@@ -44,9 +44,10 @@
 import edu.ucsb.nceas.metacat.DBSAXHandler;
 import edu.ucsb.nceas.metacat.NodeRecord;
 import edu.ucsb.nceas.metacat.service.PropertyService;
-import edu.ucsb.nceas.metacat.service.ServiceException;
 import edu.ucsb.nceas.metacat.service.ServiceService;
 import edu.ucsb.nceas.metacat.service.SkinPropertyService;
+import edu.ucsb.nceas.metacat.shared.MetacatUtilException;
+import edu.ucsb.nceas.metacat.shared.ServiceException;
 import edu.ucsb.nceas.utilities.GeneralPropertyException;
 import edu.ucsb.nceas.utilities.PropertyNotFoundException;
 import edu.ucsb.nceas.utilities.FileUtil;
Index: src/edu/ucsb/nceas/metacat/DBQuery.java
===================================================================
--- src/edu/ucsb/nceas/metacat/DBQuery.java	(revision 5014)
+++ src/edu/ucsb/nceas/metacat/DBQuery.java	(revision 5015)
@@ -48,6 +48,8 @@
 import org.xml.sax.InputSource;
 import org.w3c.dom.ls.*;
 
+import edu.ucsb.nceas.metacat.database.DBConnection;
+import edu.ucsb.nceas.metacat.database.DBConnectionPool;
 import edu.ucsb.nceas.metacat.service.PropertyService;
 import edu.ucsb.nceas.metacat.util.AuthUtil;
 import edu.ucsb.nceas.metacat.util.MetacatUtil;
Index: src/edu/ucsb/nceas/metacat/harvesterClient/MetUpload.java
===================================================================
--- src/edu/ucsb/nceas/metacat/harvesterClient/MetUpload.java	(revision 5014)
+++ src/edu/ucsb/nceas/metacat/harvesterClient/MetUpload.java	(revision 5015)
@@ -43,7 +43,7 @@
 
 import edu.ucsb.nceas.metacat.client.*;
 import edu.ucsb.nceas.metacat.service.PropertyService;
-import edu.ucsb.nceas.metacat.service.ServiceException;
+import edu.ucsb.nceas.metacat.shared.ServiceException;
 import edu.ucsb.nceas.metacat.util.SystemUtil;
 import edu.ucsb.nceas.utilities.GeneralPropertyException;
 import edu.ucsb.nceas.utilities.IOUtil;
Index: src/edu/ucsb/nceas/metacat/database/DBConnection.java
===================================================================
--- src/edu/ucsb/nceas/metacat/database/DBConnection.java	(nonexistent)
+++ src/edu/ucsb/nceas/metacat/database/DBConnection.java	(revision 5015)
@@ -0,0 +1,449 @@
+/**
+ *  '$RCSfile$'
+ *    Purpose: A class represent a connection object, it includes connction 
+ *    itself, index, status, age and usageCount.
+ *  Copyright: 2000 Regents of the University of California and the
+ *             National Center for Ecological Analysis and Synthesis
+ *    Authors: Jing Tao
+ *
+ *   '$Author$'
+ *     '$Date$'
+ * '$Revision$'
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+package edu.ucsb.nceas.metacat.database;
+
+import java.io.*;
+import java.sql.*;
+
+import org.apache.log4j.Logger;
+
+import edu.ucsb.nceas.metacat.service.PropertyService;
+import edu.ucsb.nceas.utilities.PropertyNotFoundException;
+
+/**
+ * A class represent a connection object, it includes connection itself, 
+ * index, status, age, createtime, connection time, usageCount, warning message
+ */
+ 
+public class DBConnection 
+{
+  private Connection conn;
+  private String tag;//to idenify this object
+  private int status;// free or using
+  private long age;
+  private long createTime;
+  private long connectionTime; //how long it use for connections, 
+                               //it is accumulated
+  private long checkOutTime; //the time when check it out
+  private int usageCount;// how many time the connection was used
+  private int checkOutSerialNumber; // a number to identify same check out.
+                                     //for a connection
+  private SQLWarning warningMessage;
+  private String checkOutMethodName;
+  
+  private static String  DBDriver;
+  private static String  DBConnectedJDBC;
+  private static String  userName;
+  private static String  passWord;
+  
+  private static Logger logMetacat = Logger.getLogger(DBConnection.class);
+
+  /**
+   * Default constructor of the DBConnection class 
+   * 
+   */
+  public DBConnection()  throws SQLException
+  {
+	try {
+		DBDriver = PropertyService.getProperty("database.driver");
+		DBConnectedJDBC = PropertyService.getProperty("database.connectionURI");
+		userName = PropertyService.getProperty("database.user");
+		passWord = PropertyService.getProperty("database.password");
+	} catch (PropertyNotFoundException pnfe) {
+		System.err.println("Could not get property in static block: "
+			+ pnfe.getMessage());
+	}
+	  
+    conn = openConnection();
+    tag = conn.toString();
+    status = 0;
+    age = 0;
+    createTime = System.currentTimeMillis();
+    connectionTime = 0;
+    checkOutTime = 0;
+    usageCount= 0;
+    checkOutSerialNumber=0;
+    warningMessage = null;
+    checkOutMethodName = null;
+    
+  }
+  
+ 
+  
+  /**
+   * get the  connetion from the object
+   */
+  public Connection getConnections()
+  {
+    return conn;
+  }
+  
+  /**
+   * Set a connection to this object
+   * @param myDBConnection, the connection which will be assign to this object
+   */
+  public void setConnections( Connection myConnection)
+  {
+    this.conn = myConnection;
+  }
+
+  /**
+   * get the db connetion tag from the object
+   */
+  public String getTag()
+  {
+    return tag;
+  }
+  
+  /**
+   * Set a connection status to this object
+   * @param myTag, the tag which will be assign to this object
+   */
+  public void setTag(String myTag)
+  {
+    this.tag = myTag;
+  }
+  
+  /**
+   * get the db connetion status from the object
+   */
+  public int getStatus()
+  {
+    return status;
+  }
+  
+  /**
+   * Set a connection status to this object
+   * @param myStatus, the status which will be assign to this object
+   * 0 is free, 1 is using
+   */
+  public void setStatus(int myStatus)
+  {
+    this.status = myStatus;
+  }
+  
+  /**
+   * get the db connetion age from the object
+   */
+  public long getAge()
+  {
+    return (System.currentTimeMillis() - createTime);
+  }
+  
+ 
+  /**
+   * Set a connection age to this object
+   * @param myAge, the Age which will be assign to this object
+   */
+  public void setAge(long myAge)
+  {
+    this.age = myAge;
+  }  
+  
+  /**
+   * get the db connetion created time from the object
+   */
+  public long getCreateTime()
+  {
+    return createTime;
+  }
+  
+  /**
+   * Set a usage number to this object
+   * @param myCreateTime, the create time which will be assign to this object
+   */
+  public void setCreateTime(long myCreateTime)
+  {
+    this.createTime = myCreateTime;
+  }
+  
+  /**
+   * get the how long db connetion used for the object
+   */
+  public long getConnectionTime()
+  {
+    return connectionTime;
+  }
+  
+ 
+  /**
+   * Set a connection time to this object
+   * It is accumulated
+   * @param myConnectionTime, the connection time which will assign to
+   * this object
+   */
+  public void setConnectionTime(long myConnectionTime)
+  {
+    this.connectionTime = this.connectionTime + myConnectionTime;
+  }
+  
+  /**
+   * get the when a db connetion was checked out
+   */
+  public long getCheckOutTime()
+  {
+    return checkOutTime;
+  }
+  
+ 
+  /**
+   * Set check out time to this object
+  
+   * @param myCheckOutTime, the check out time which will assign to
+   * this object
+   */
+  public void setCheckOutTime(long myCheckOutTime)
+  {
+    this.checkOutTime = myCheckOutTime;
+  }
+  
+  /**
+   * get the db connetion usage times from the object
+   */
+  public int getUsageCount()
+  {
+    return usageCount;
+  }
+   
+ 
+  /**
+   * Set a usage number to this object
+   * @param myUsageCount, number of usage which will be assign to this object
+   */
+  public void setUsageCount(int myUsageCount)
+  {
+    this.usageCount = myUsageCount;
+  }
+  
+  /**
+   * Increase a usage number to this object
+   * @param myUsageCount, number of usage which will be add to this object
+   */
+  public void increaseUsageCount(int myUsageCount)
+  {
+    this.usageCount = this.usageCount + myUsageCount;
+  }  
+  
+  /**
+   * get the check out serial number
+   */
+  public int getCheckOutSerialNumber()
+  {
+    return checkOutSerialNumber;
+  }
+  
+ 
+  /**
+   * Set check out serial number to this object
+  
+   * @param myCheckOutSerialNumber, the check out serial number which will 
+   * assign to this object
+   */
+  public void setCheckOutSerialNumber(int myCheckOutSerialNumber)
+  {
+    this.checkOutSerialNumber = myCheckOutSerialNumber;
+  }
+  
+  /**
+   * Increase a usage number to this object
+   * @param myUsageCount, number of usage which will be add to this object
+   */
+  public void increaseCheckOutSerialNumber(int myCheckOutSerialNumber)
+  {
+    this.checkOutSerialNumber=this.checkOutSerialNumber+myCheckOutSerialNumber;
+  }  
+  
+  
+  /**
+   * get the db connetion waring message from the object
+   */
+  public SQLWarning getWarningMessage() throws SQLException
+  {
+    //should increase 1 UsageCount
+    increaseUsageCount(1);
+    return conn.getWarnings();
+  }
+  
+  /**
+   * Set a warning message to this object
+   * @param myWarningMessage, the waring which will be assign to this object
+   */
+  public void setWarningMessage(SQLWarning myWarningMessage)
+  {
+     this.warningMessage = myWarningMessage;
+  }
+  
+  /**
+   * get the the name of method checked out the connection from the object
+   */
+  public String getCheckOutMethodName()
+  {
+    return checkOutMethodName;
+  }
+  
+  /**
+   * Set a method name to the checkOutMethodName 
+   * @param myCheckOutMethodName, the name of method will assinged to it
+   */
+  public void setCheckOutMethodName(String myCheckOutMethodName)
+  {
+     this.checkOutMethodName = myCheckOutMethodName;
+  }
+  
+  /**
+   * Close a DBConnection object
+   */
+  public void close() throws SQLException
+  {
+    conn.close();
+    tag = null;
+    status = 0;
+    age = 0;
+    createTime = System.currentTimeMillis();
+    connectionTime = 0;
+    checkOutTime = 0;
+    usageCount= 0;
+    warningMessage = null;
+  }
+  
+    /** 
+   * Method to establish DBConnection 
+   */
+  public static Connection openConnection()
+                  throws SQLException 
+  {
+    return openConnection(DBDriver, DBConnectedJDBC, userName, passWord);
+  }//openDBConnection
+
+  /** 
+   * Method to establish a JDBC database connection 
+   *
+   * @param dbDriver the string representing the database driver
+   * @param connection the string representing the database connectin parameters
+   * @param user name of the user to use for database connection
+   * @param password password for the user to use for database connection
+   */
+  private static Connection openConnection(String dbDriver, String connection,
+                String user, String password)
+                throws SQLException
+ {
+     // Load the Oracle JDBC driver
+     try
+     {
+       Class.forName (dbDriver);
+     }
+     catch (ClassNotFoundException e)
+     {
+       logMetacat.error("Error in DBConnectionPool "+e.getMessage());
+       return null;
+     }
+     // Connect to the database
+     Connection connLocal = null;
+     connLocal = DriverManager.getConnection( connection, user, password);
+     return connLocal;
+  }//OpenDBConnection
+  
+  /** 
+   * Method to test a JDBC database connection 
+   *
+   * @param dbDriver the string representing the database driver
+   * @param connection the string representing the database connectin parameters
+   * @param user name of the user to use for database connection
+   * @param password password for the user to use for database connection
+   */
+  public static void testConnection(String dbDriver, String connection,
+                String user, String password)
+                throws SQLException
+  {
+     // Load the Oracle JDBC driver
+     try
+     {
+       Class.forName (dbDriver);
+     }
+     catch (ClassNotFoundException e)
+     {
+       throw new SQLException(e.getMessage());
+     }
+     // Connect to the database
+     Connection connLocal = null;
+     connLocal = DriverManager.getConnection( connection, user, password);
+     connLocal.close();
+  }
+  
+  /**
+   * Method to create a PreparedStatement by sending a sql statement
+   * @Param sql, the sql statement which will be sent to db
+   */
+  public PreparedStatement prepareStatement( String sql ) throws SQLException
+  {
+    return conn.prepareStatement(sql);
+  }//prepareStatement
+  
+  
+  /**
+   * Method to create a Statement
+   */
+  public Statement createStatement() throws SQLException
+  {
+    return conn.createStatement();
+  }//prepareStatement
+
+  /**
+   * Method to make a commit command
+   */
+  public void commit() throws SQLException
+  {
+    conn.commit();
+  }//commit
+  
+  /**
+   * Method to set commit mode
+   * @param autocommit, true of false to auto commit
+   */
+  public void setAutoCommit( boolean autoCommit) throws SQLException
+  {
+    conn.setAutoCommit(autoCommit);
+  }//setAutoCommit
+  
+  /**
+   * Method to roll back
+   */
+  public void rollback() throws SQLException
+  {
+    conn.rollback();
+  }//rollback
+  
+  /**
+   * Method to get meta data
+   */
+  public DatabaseMetaData getMetaData() throws SQLException
+  {
+    return conn.getMetaData();
+  }//getMetaData
+  
+}//DBConnection class

Index: src/edu/ucsb/nceas/metacat/shared/AccessException.java
===================================================================
--- src/edu/ucsb/nceas/metacat/shared/AccessException.java	(nonexistent)
+++ src/edu/ucsb/nceas/metacat/shared/AccessException.java	(revision 5015)
@@ -0,0 +1,51 @@
+/**
+ *  '$RCSfile$'
+ *    Purpose: An Exception thrown when an error occurs because an 
+ *             AccessionNumber was invalid or used incorrectly
+ *  Copyright: 2008 Regents of the University of California and the
+ *             National Center for Ecological Analysis and Synthesis
+ *    Authors: Michael Daigle
+ *
+ *   '$Author: daigle $'
+ *     '$Date: 2008-07-06 21:25:34 -0700 (Sun, 06 Jul 2008) $'
+ * '$Revision: 4080 $'
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+package edu.ucsb.nceas.metacat.shared;
+
+
+/**
+ * Exception thrown when an error occurs in a configuration administrative
+ * class
+ */
+public class AccessException extends BaseException {
+	
+	private static final long serialVersionUID = -8436697355629175917L;
+
+	/**
+	 * Create a new AccessException.
+	 *
+	 * @param message The error or warning message.
+	 */
+	public AccessException(String message) {
+		super(message);
+	}
+	
+	public AccessException(String message, BaseException deeperException) {
+		super(message, deeperException);
+	}
+}

